// @ifndef NATIVE

define([''],function() {

	/**
	 * An 'interface' to interacte with native model.
	 * The real one is injected by QT.
	 */
    var NativeModel = function () {

    }

    /**
     * Load map Json
     * @param {string} mapId
     * @returns {string} Map Json as string
     */
    NativeModel.prototype.findMap = function(mapId)
    {

//	$.getJSON("resources/exampleMap.json", function(data)
//	$.getJSON("resources/exampleMap-simple.json", function(data)
//	$.getJSON("resources/exampleMap-node.json", function(data)
        var resource = this.findAssetBaseUrl(mapId) + "/map.json";
        $.ajax({
            type: "GET",
            dataType: 'json',
            url: resource,
            async: false,
        success: function(data, text)
        {
            return request.responseText;
        },
        error: function(request, status, error){
            return;
        }
        });

        //return '{"mapProps":{"mapName":"Titolo","_preMapName":"Titolo","author":"","className":"","date":"","comments":""},"nodes":[{"id":"map9175953","nodeData":{"nodeType":"roundrect","frame":false,"textLayout":"inside","textProperties":{"bold":false,"italic":false,"size":3,"editing":false},"brushColor":"rgba(51, 187, 204, 1)","penColor":"rgb(51, 187, 204)","penColorId":9,"penWidth":"4","children":0,"language":"","mode":true,"deepFillColor":"#FFFFFF","borderRadius":5},"nodeTable":{"tableID":"","tableRow":-1,"tableCol":-1},"geometry":{"x":1029,"y":100,"width":250,"height":80,"x1":0,"y1":0,"x2":0,"y2":0,"imgW":0,"imgH":0,"txtW":240,"txtH":70},"image":{"name":"","transparent":false,"custom":false},"titleText":"","deepText":"","links":[],"comment":{"text":"","editing":false}},{"id":"map1848610","nodeData":{"nodeType":"roundrect","frame":false,"textLayout":"inside","textProperties":{"bold":false,"italic":false,"size":3,"editing":false},"brushColor":"rgba(248, 231, 28, 0.15)","penColor":"rgb(248, 231, 28)","penColorId":6,"penWidth":"4","children":0,"language":"","mode":false,"deepFillColor":"#FFFFFF","borderRadius":5},"nodeTable":{"tableID":"","tableRow":-1,"tableCol":-1},"geometry":{"x":372,"y":329,"width":250,"height":80,"x1":0,"y1":0,"x2":0,"y2":0,"imgW":0,"imgH":0,"txtW":240,"txtH":70},"image":{"name":"","transparent":false,"custom":false},"titleText":"","deepText":"","links":[],"comment":{"text":"","editing":false},"isCreatingEdge":false}],"edges":[{"id":"e72797","directed":false,"source":"map1848610","target":"map9175953","edgeData":{"type":"none","penColor":"rgb(155, 89, 182)","penColorId":2,"penWidth":"4","drawOver":false,"curve":false,"ctrlPx":0,"ctrlPy":0,"language":"","textProperties":{"bold":false,"italic":false}},"titleText":""}]}';
    //return '{"mapProps":{"mapName":"Titolo","_preMapName":"Titolo","author":"melotti100@dudat.it","className":"","date":"Tue Mar 31 10:13:34 2015","comments":""},"nodes":[{"id":"map9175179","nodeData":{"nodeType":"roundrect","frame":false,"textLayout":"inside","textProperties":{"bold":false,"italic":false,"size":3,"editing":false},"brushColor":"rgba(189, 195, 199, 1)","penColor":"rgb(189, 195, 199)","penColorId":1,"penWidth":"4","children":0,"language":"","mode":true,"deepFillColor":"#FFFFFF","borderRadius":5},"nodeTable":{"tableID":"","tableRow":-1,"tableCol":-1},"geometry":{"x":222.5,"y":100,"width":250,"height":317.67499999999995,"x1":0,"y1":0,"x2":0,"y2":0,"imgW":0,"imgH":0,"txtW":240,"txtH":70},"image":{"name":"","transparent":false,"custom":false},"titleText":"re rinascimentali fa riferimento ai principi proporzionali della fi gura umana, basati sul quadrato e sul cerchio, derivati dal trattato dell’architetto romano Vitruvio. (Francesco di Giorgio Martini, Proporzionamento della pianta di un edifi cio sacro in base al corpo umano, circa 1489. Firenze, Biblioteca Nazionale)","deepText":"","links":[],"comment":{"text":"","editing":false}},{"id":"map1078710","nodeData":{"nodeType":"roundrect","frame":false,"textLayout":"inside","textProperties":{"bold":false,"italic":true,"size":3,"editing":false},"brushColor":"rgba(189, 195, 199, 0.15)","penColor":"rgb(189, 195, 199)","penColorId":1,"penWidth":"4","children":0,"language":"","mode":false,"deepFillColor":"#FFFFFF","borderRadius":5},"nodeTable":{"tableID":"","tableRow":-1,"tableCol":-1},"geometry":{"x":454,"y":358.8375,"width":250,"height":80,"x1":0,"y1":0,"x2":0,"y2":0,"imgW":0,"imgH":0,"txtW":240,"txtH":70},"image":{"name":"","transparent":false,"custom":false},"titleText":"pipop ciao blablabl","deepText":"","links":[],"comment":{"text":"","editing":false}}],"edges":[]}';
   //return '{"mapProps":{"mapName":"firstMap"},"nodes":[{"id":"n001","deepText": "prova", "nodeData":{"nodeType":"roundrect","frame":false, "textLayout":"inside","brushColor":"#00ffff","penColor":"#0000ff","penWidth":"1"},"geometry":{"x":200,"y":70,"width":120,"height":80,"x1":140,"y1":60,"x2":260,"y2":140,"imgW":0,"imgH":0,"txtW":100,"txtH":20},"titleText":"<span style=\'background-color:red;\'>n001 <strong>Titolo </strong>di prova</span>"},{"id":"n002","nodeData":{"nodeType":"rectangle","frame":false,"textLayout":"under","brushColor":"#ff00ff","penColor":"#00ff00","penWidth":"2"},"geometry":{"x":200,"y":200,"width":120,"height":80,"x1":240,"y1":160,"x2":360,"y2":240,"imgW":0,"imgH":0,"txtW":100,"txtH":20},"titleText":"n002 Altro titolo"},{"id":"n003","nodeData":{"nodeType":"ellipse","frame":false,"textLayout":"inside","brushColor":"#00ffff","penColor":"#ff0000","penWidth":"3"},"geometry":{"x":200,"y":300,"width":120,"height":80,"x1":140,"y1":260,"x2":260,"y2":340,"imgW":0,"imgH":0,"txtW":100,"txtH":20},"titleText":"<div style=\'text-align: right;\'>n003 <strong>Titolo </strong>immagine</div>"},{"id":"n004","nodeData":{"nodeType":"image","frame":true,"textLayout":"under","brushColor":"#ffffff","penColor":"#0000ff","penWidth":"0"},"geometry":{"x":500,"y":300,"width":120,"height":80,"x1":440,"y1":260,"x2":560,"y2":340,"imgW":0,"imgH":0,"txtW":100,"txtH":20},"image":{"name":"resources/test01.png"},"titleText":"n004 Titolo di prova"},{"id":"n005","nodeData":{"nodeType":"text","frame":false,"textLayout":"inside","brushColor":"#00ffff","penColor":"#0000ff","penWidth":"1"},"geometry":{"x":700,"y":100,"width":250,"height":50,"x1":600,"y1":90,"x2":800,"y2":120,"imgW":0,"imgH":0,"txtW":250,"txtH":50},"titleText":"Testo multiriga, varia roba e quant\'altro piuttosto che nulla."},{"id":"n006","nodeData":{"nodeType":"image","frame":true,"textLayout":"under","brushColor":"#ffffff","penColor":"#0000ff","penWidth":"0"},"geometry":{"x":500,"y":500,"width":120,"height":80,"x1":440,"y1":460,"x2":560,"y2":540,"imgW":0,"imgH":0,"txtW":100,"txtH":20},"image":{"name":"resources/test02.jpg"},"titleText":"n006 Immagine"}],"edges":[{"id":"e001","directed":true,"source":"n001","target":"n002","edgeData":{"type":"forward","penColor":"rgba(41, 128, 185, 1.0)","penWidth":"3","drawOver":true,"curve":false,"ctrlPx":0,"ctrlPy":0},"titleText":"<span style=\'background-color: white;\'><strong>Titolo freccia</span>"},{"id":"e002","directed":true,"source":"n003","target":"n006","edgeData":{"type":"forward","penColor":"#FF8080","penWidth":"3","drawOver":true,"curve":true,"ctrlPx":350,"ctrlPy":550},"titleText":"<span style=\'background-color: white;\'>Altra freccia</span>"},{"id":"e003","directed":true,"source":"n001","target":"n004","edgeData":{"type":"backward","penColor":"#C0C0C0","penWidth":"3","drawOver":true,"curve":false,"ctrlPx":0,"ctrlPy":0},"titleText":"<span style=\'background-color: white;\'>ciao</span>"},{"id":"e004","directed":true,"source":"n002","target":"n004","edgeData":{"type":"backward","penColor":"#C0C0C0","penWidth":"3","drawOver":true,"curve":false,"ctrlPx":0,"ctrlPy":0},"titleText":""},{"id":"e005","directed":true,"source":"n003","target":"n004","edgeData":{"type":"forward","penColor":"#C0C0C0","penWidth":"3","drawOver":true,"curve":false,"ctrlPx":0,"ctrlPy":0},"titleText":""},{"id":"e006","directed":true,"source":"n004","target":"n005","edgeData":{"type":"forward","penColor":"#C0C0C0","penWidth":"3","drawOver":true,"curve":false,"ctrlPx":0,"ctrlPy":0},"titleText":""},{"id":"e007","directed":true,"source":"n006","target":"n004","edgeData":{"type":"both","penColor":"#C0C0C0","penWidth":"3","drawOver":true,"curve":false,"ctrlPx":0,"ctrlPy":0},"titleText":""}]}';

        //return '{"mapProps":{"mapName":"Titolo","_preMapName":"Titolo","author":"","className":"","date":"","comments":""},"nodes":[{"id":"map8784989","nodeData":{"nodeType":"roundrect","frame":false,"textLayout":"inside","textProperties":{"bold":false,"italic":false,"size":3,"editing":false},"brushColor":"rgba(189, 195, 199, 1)","penColor":"rgb(189, 195, 199)","penColorId":1,"penWidth":"4","children":0,"language":"","mode":true,"tempMode":true,"deepFillColor":"#FFFFFF","borderRadius":5},"nodeTable":{"tableID":"","tableRow":-1,"tableCol":-1},"geometry":{"x":1605,"y":209.5,"width":344,"height":351.26398315429685,"x1":0,"y1":0,"x2":0,"y2":0,"imgW":0,"imgH":0,"txtW":240,"txtH":140},"image":{"name":"resources/test02.jpg","transparent":false,"custom":false},"titleText":"fdfd","deepText":"","links":[],"comment":{"text":"","editing":false},"assetBasePath":"resources/defaultMapId"},{"id":"map8497182","nodeData":{"nodeType":"roundrect","frame":false,"textLayout":"inside","textProperties":{"bold":false,"italic":false,"size":3,"editing":false},"brushColor":"rgba(189, 195, 199, 0.15)","penColor":"rgb(189, 195, 199)","penColorId":1,"penWidth":"4","children":0,"language":"","mode":false,"tempMode":false,"deepFillColor":"#FFFFFF","borderRadius":5},"nodeTable":{"tableID":"","tableRow":-1,"tableCol":-1},"geometry":{"x":1083,"y":382.5,"width":250,"height":80,"x1":0,"y1":0,"x2":0,"y2":0,"imgW":0,"imgH":0,"txtW":240,"txtH":70},"image":{"name":"","transparent":false,"custom":false},"titleText":"","deepText":"","links":[],"comment":{"text":"","editing":false},"assetBasePath":"resources/defaultMapId","isCreatingEdge":false}],"edges":[{"id":"e1088317","directed":false,"source":"map8497182","target":"map8784989","edgeData":{"type":"none","penColor":"rgb(189, 195, 199)","penColorId":1,"penWidth":"4","drawOver":false,"curve":false,"ctrlPx":0,"ctrlPy":0,"language":"","textProperties":{"bold":false,"italic":false}},"titleText":""}]}';
    //return '{"edges":[{"directed":false,"edgeData":{"ctrlPx":0,"ctrlPy":0,"curve":false,"drawOver":false,"language":"","penColor":"rgba(189, 195, 199, 1.0)","penWidth":"4","type":"none"},"id":"e2611283","source":"map4706768","target":"map5082692","titleText":"jllkjlòjlòkjòl"}],"mapProps":{"author":"","classname":"","comments":"","date":"","mapName":"Titolo"},"nodes":[{"deepText":"","geometry":{"height":80,"imgH":0,"imgW":0,"txtH":70,"txtW":240,"width":250,"x":169.5,"x1":169.5,"x2":169.5,"y":108,"y1":108,"y2":108},"id":"map5082692","image":{"custom":false,"name":"","transparent":false},"links":[],"nodeData":{"brushColor":"rgba(51, 187, 204, 1.0)","children":0,"deepFillColor":"rgba(255, 255, 255, 1.0)","frame":false,"language":"","nodeType":"roundrect","penColor":"rgba(51, 187, 204, 1.0)","penWidth":"4","textLayout":"inside"},"nodeTable":{"tableCol":0,"tableId":"","tableRow":0},"titleText":"asdfasfasdf"},{"deepText":"","geometry":{"height":80,"imgH":0,"imgW":0,"txtH":70,"txtW":240,"width":250,"x":252.5,"x1":252.5,"x2":252.5,"y":375,"y1":375,"y2":375},"id":"map4706768","image":{"custom":false,"name":"","transparent":false},"links":[],"nodeData":{"brushColor":"rgba(243, 156, 18, 1.0)","children":0,"deepFillColor":"rgb(255,255,255)","frame":false,"language":"","nodeType":"roundrect","penColor":"rgb(243, 156, 18)","penWidth":"4","textLayout":"inside"},"nodeTable":{"tableCol":0,"tableId":"","tableRow":0},"titleText":"asdfasdfasdf2222"}],"structure":{"edited":false,"hasStructure":false,"readOrder":[]}}'
       //return  '{"mapProps":{"author":"","classname":"","comments":"","date":"","mapName":"Titolo"},"nodes":[{"id":"map5082692","nodeData":{"nodeType":"roundrect","frame":false,"textLayout":"inside","textProperties":{"bold":false,"italic":false,"size":3,"editing":false},"brushColor":"rgba(51, 187, 204, 0.15)","penColor":"rgb(51, 187, 204)","penColorId":1,"penWidth":"4","children":0,"language":"","mode":false,"tempMode":false,"deepFillColor":"rgba(255, 255, 255, 1.0)","borderRadius":5},"nodeTable":{"tableID":"","tableRow":0,"tableCol":0,"tableId":""},"geometry":{"x":169.5,"y":108,"width":250,"height":80,"x1":169.5,"y1":108,"x2":169.5,"y2":108,"imgW":0,"imgH":0,"txtW":240,"txtH":70},"image":{"name":"","transparent":false,"custom":false},"titleText":"asdfasfasdf","deepText":"dsa","links":[],"comment":{"text":"","editing":false},"assetBasePath":"resources/defaultMapId"},{"id":"map4706768","nodeData":{"nodeType":"roundrect","frame":false,"textLayout":"inside","textProperties":{"bold":false,"italic":false,"size":3,"editing":false},"brushColor":"rgba(243, 156, 18, 0.15)","penColor":"rgb(243, 156, 18)","penColorId":1,"penWidth":"4","children":0,"language":"","mode":false,"tempMode":false,"deepFillColor":"rgb(255,255,255)","borderRadius":5},"nodeTable":{"tableID":"","tableRow":0,"tableCol":0,"tableId":""},"geometry":{"x":252.5,"y":375,"width":250,"height":80,"x1":252.5,"y1":375,"x2":252.5,"y2":375,"imgW":0,"imgH":0,"txtW":240,"txtH":70},"image":{"name":"","transparent":false,"custom":false},"titleText":"asdfasdfasdf2222","deepText":"fds","links":[],"comment":{"text":"","editing":false},"assetBasePath":"resources/defaultMapId"}],"edges":[{"id":"e2611283","directed":false,"source":"map4706768","target":"map5082692","edgeData":{"type":"none","penColor":"rgba(189, 195, 199, 1.0)","penColorId":1,"penWidth":"4","drawOver":false,"curve":false,"ctrlPx":0,"ctrlPy":0,"language":"","textProperties":{"bold":false,"italic":false}},"titleText":"jllkjlòjlòkjòl"}]}';
    //return   '{"mapProps":{"mapName":"Titolo prova","author":"","className":"","date":"","comments":""},"nodes":[{"id":"map8595029","nodeData":{"nodeType":"roundrect","frame":false,"textLayout":"inside","textProperties":{"bold":false,"italic":false,"size":3,"editing":false},"brushColor":"rgb(230, 126, 34)","penColor":"rgb(230, 126, 34)","penColorId":1,"penWidth":4,"children":0,"language":"","mode":true,"tempMode":true,"deepFillColor":"#FFFFFF","borderRadius":5},"nodeTable":{"tableID":"","tableRow":-1,"tableCol":-1},"geometry":{"x":490,"y":279.5,"width":250,"height":80,"x1":490,"y1":279.5,"x2":490,"y2":279.5,"imgW":0,"imgH":0,"txtW":240,"txtH":70},"image":{"name":"","transparent":false,"custom":false},"titleText":"map8595029","deepText":"","links":[],"comment":{"text":"","editing":false},"assetBasePath":"resources/defaultMapId"},{"id":"map8154529","nodeData":{"nodeType":"roundrect","frame":false,"textLayout":"inside","textProperties":{"bold":false,"italic":false,"size":3,"editing":false},"brushColor":"rgba(189,195,199,0.15)","penColor":"rgb(255, 255, 255)","penColorId":1,"penWidth":4,"children":0,"language":"","mode":false,"tempMode":false,"deepFillColor":"#FFFFFF","borderRadius":5},"nodeTable":{"tableID":"","tableRow":-1,"tableCol":-1},"geometry":{"x":979,"y":169.5,"width":250,"height":80,"x1":979,"y1":169.5,"x2":979,"y2":169.5,"imgW":0,"imgH":0,"txtW":240,"txtH":70},"image":{"name":"","transparent":false,"custom":false},"titleText":"map8154529","deepText":"","links":[],"comment":{"text":"","editing":false},"assetBasePath":"resources/defaultMapId"}],"edges":[{"id":"e8651567","directed":false,"source":"map8595029","target":"map8154529","edgeData":{"type":"none","penColor":"rgb(189, 195, 199)","penColorId":1,"penWidth":"4","drawOver":false,"curve":true,"ctrlPx":669.8333333333334,"ctrlPy":86.5,"language":""},"titleText":"map8154529"}]}';
      //return  '{"mapProps":{"mapName":"Titolo prova","author":"","className":"","date":"","comments":""},"nodes":[{"id":"map8595029","nodeData":{"nodeType":"roundrect","frame":false,"textLayout":"inside","textProperties":{"bold":false,"italic":false,"size":3,"editing":false},"brushColor":"rgba(189,195,199,1)","penColor":"rgb(189, 195, 199)","penColorId":1,"penWidth":4,"children":0,"language":"","mode":true,"tempMode":true,"deepFillColor":"#FFFFFF","borderRadius":5},"nodeTable":{"tableID":"","tableRow":-1,"tableCol":-1},"geometry":{"x":490,"y":279.5,"width":250,"height":80,"x1":490,"y1":279.5,"x2":490,"y2":279.5,"imgW":0,"imgH":0,"txtW":240,"txtH":70},"image":{"name":"","transparent":false,"custom":false},"titleText":"map8595029","deepText":"","links":[],"comment":{"text":"","editing":false},"assetBasePath":"resources/defaultMapId"},{"id":"map8154529","nodeData":{"nodeType":"roundrect","frame":false,"textLayout":"inside","textProperties":{"bold":false,"italic":false,"size":3,"editing":false},"brushColor":"rgba(189,195,199,0.15)","penColor":"rgb(189, 195, 199)","penColorId":1,"penWidth":4,"children":0,"language":"","mode":false,"tempMode":false,"deepFillColor":"#FFFFFF","borderRadius":5},"nodeTable":{"tableID":"","tableRow":-1,"tableCol":-1},"geometry":{"x":979,"y":169.5,"width":250,"height":80,"x1":979,"y1":169.5,"x2":979,"y2":169.5,"imgW":0,"imgH":0,"txtW":240,"txtH":70},"image":{"name":"","transparent":false,"custom":false},"titleText":"map8154529","deepText":"","links":[],"comment":{"text":"","editing":false},"assetBasePath":"resources/defaultMapId"},{"id":"map8139227","nodeData":{"nodeType":"roundrect","frame":false,"textLayout":"inside","textProperties":{"bold":false,"italic":false,"size":3,"editing":false},"brushColor":"rgba(189,195,199,0.15)","penColor":"rgb(189, 195, 199)","penColorId":1,"penWidth":4,"children":0,"language":"","mode":false,"tempMode":false,"deepFillColor":"#FFFFFF","borderRadius":5},"nodeTable":{"tableID":"","tableRow":-1,"tableCol":-1},"geometry":{"x":328.5,"y":80.5,"width":250,"height":80,"x1":328.5,"y1":80.5,"x2":328.5,"y2":80.5,"imgW":0,"imgH":0,"txtW":240,"txtH":70},"image":{"name":"","transparent":false,"custom":false},"titleText":"map8139227","deepText":"","links":[],"comment":{"text":"","editing":false},"assetBasePath":"resources/defaultMapId"}],"edges":[{"id":"e8651567","directed":false,"source":"map8595029","target":"map8154529","edgeData":{"type":"none","penColor":"rgb(189, 195, 199)","penColorId":1,"penWidth":"4","drawOver":false,"curve":true,"ctrlPx":669.8333333333334,"ctrlPy":86.5,"language":""},"titleText":"map8154529"},{"id":"e8710464","directed":false,"source":"map8595029","target":"map8139227","edgeData":{"type":"none","penColor":"rgb(189, 195, 199)","penColorId":1,"penWidth":"4","drawOver":false,"curve":false,"ctrlPx":0,"ctrlPy":0,"language":""},"titleText":"map8139227"}]}'
    };

    /**
     * @param {string} mapId
     * @returns {string} asset base dir path
     */
    NativeModel.prototype.findAssetBaseUrl = function(mapId)
    {
        return "resources/" + mapId;
    }

    return NativeModel;
});

// @endif
