if (window['CSS3TransformationKey']==undefined) (function() { var prefixes = 'transform WebkitTransform MozTransform OTransform msTransform'.split(' '), elSupport = document.createElement('div'), support=0, found = false; while( !found && support<prefixes.length ){ found = document.createElement('div').style[prefixes[support]] != undefined; if (found) window['CSS3TransformationKey']=transformPrefix = prefixes[support]; else support++; } var cssprefix = window['CSS3TransformationKey'].toLowerCase().replace('transform',''); if (cssprefix.length!=0) cssprefix = '-'+cssprefix+'-'; window['CSS3TransformationPrefix'] = cssprefix})();
if (window['CSS3TransitionKey']==undefined) (function() { var prefixes = 'transition WebkitTransition MozTransition OTransition msTransition'.split(' '), elSupport = document.createElement('div'), support=0, found = false; while( !found && support<prefixes.length ){ found = document.createElement('div').style[prefixes[support]] != undefined; if (found) window['CSS3TransitionKey']=transformPrefix = prefixes[support]; else support++; } var cssprefix = window['CSS3TransitionKey'].toLowerCase().replace('transform',''); if (cssprefix.length!=0) cssprefix = '-'+cssprefix+'-'; window['CSS3TransitionPrefix'] = cssprefix})();

isNumeric = function(n) {
	if (typeof(n) == 'string') {
		n = n.replace(/,/,'.');
		return !isNaN(parseFloat(n)) && isFinite(n);
	}
	return false;
}

sortAssoc = function(aInput){
	var aTemp = [];
	for (var sKey in aInput) aTemp.push([sKey, aInput[sKey]]);
	aTemp.sort(function () {return arguments[1][1] - arguments[0][1]});
	var aOutput = [];
	for (var nIndex = aTemp.length-1; nIndex >=0; nIndex--)
	aOutput[aTemp[nIndex][0]] = aTemp[nIndex][1];
	return aOutput;
}

BrowserInfo = {
	Android: function() { return navigator.userAgent.match(/Android/i); },
	BlackBerry: function() { return navigator.userAgent.match(/BlackBerry/i); },
	iOS: function() { return navigator.userAgent.match(/iPhone|iPad|iPod/i); },
	OperaMini: function() { return navigator.userAgent.match(/Opera Mini/i); },
	Opera: function() { return navigator.userAgent.match(/Opera/i); },
	WindowsPhone: function() { return navigator.userAgent.match(/IEMobile/i); },
	Webkit: function() { return navigator.userAgent.match(/Webkit/i); },
	Chrome: function() { return navigator.userAgent.match(/Chrome/i); },
	Firefox: function() { return navigator.userAgent.match(/Firefox/i); },
	Ie: function() { return navigator.userAgent.match(/MSIE/i); },
};

for (var k in BrowserInfo) {
	BrowserInfo['is'+k] = BrowserInfo[k]();
}

matrixToArray = function(matrix) {
	if (matrix=="none") return [1,0,0,1,0,0];
    return matrix.substr(7, matrix.length - 8).split(', ');
}

transition = function(elem,prop,time,callback) {
	var el = $(elem);
	var trmatrix = matrixToArray(el.css('transform'));
	var translateX = parseFloat(trmatrix[4]);
	var translateY = parseFloat(trmatrix[5]);
	if (Modernizr.csstransitions && Modernizr.csstransforms3d){
		if (prop['translateX']!=undefined) translateX = prop['translateX'];
    	if (prop['translateY']!=undefined) translateY = prop['translateY'];
		var transitionString = '';
		for (var k in prop) {
			if (transitionString!="") transitionString += ', ';
			if (k == 'translateX' || k == 'translateY' && transitionString.indexOf('transform')==-1) {
				transitionString += window['CSS3TransformationPrefix']+'transform '+time+'ms';
			} else {
				transitionString += k+' '+time+'ms';
			}
		}
		el[0].style[window['CSS3TransitionKey']] = transitionString;
		if (prop['translateX']!=undefined || prop['translateY']!=undefined) {
			if(translateX > 600){
				translateX = 599;
			} else if(translateX > -20 && translateX < 0) {
				translateX = 10;
			} else if(translateX < -20) {
				translateX = 15;
			}		
			var transform = 'matrix(1, 0, 0, 1, '+translateX+', '+translateY+')';
			el[0].style[window['CSS3TransformationKey']] = transform;
			delete prop['translateX'];
			delete prop['translateY'];
		}
		for (var k in prop) {
			el[0].style[k] = prop[k];
		}
		setTimeout( function() {
			if (callback) callback();
		}, time+1);
	} else {
		el.stop().clearQueue().animate(prop, time, function() {
			if (callback) callback();
		});
	}
}

cloneObject = function(obj){
	var r = {};
	for(var n in obj){
		r[n] = obj[n];
	}
	return r;
}

/*var options = {};
options.keyword = "alfred";
options.commands = [
	{
		command: ['apri','focalizza','dammi informazioni'],
		attribute: [function(lstr) {
			var ar = lstr.split(' ');
			var r = null;
			var i = 0;
			while (r==null && i<ar.length) {
				var str = ar[i];
				var strCap = str.charAt(0).toUpperCase() + str.slice(1).toLowerCase();
				var models = periodicTableView.zElements.where({name : strCap});
				if (models.length>0) r = models[0];
				i++;
			}
			return r;
		}],
		callback: function(model) {
			if (model) {
				model.set('active', true);
			}
		}
	},
	{
		command: ['chiudi scheda'],
		attribute: [],
		callback: function(str) {
			periodicTableView.focusView.close()
		}
	},
	{
		command: ['apri approfondimento'],
		attribute: [],
		callback: function(str) {
			console.log('dai');
			if (periodicTableView.focusView.isOpen && !periodicTableView.focusView.plusOpen && periodicTableView.focusView.$('.plus').is(':visible')) {
				periodicTable.focusView.openPlus();
			}
		}
	}
]
options.lang = "it-IT";

var rs = new VocalDriving(options);*/
