// @ifndef NATIVE
define([''],function() {

    /**
     * An 'interface' to notificate something to native app.
     * The real one is injected by QT.
     */
    var NativeApp = function ()
    {}

    /**
     * Notificates that webapp is loaded
     */
    NativeApp.prototype.onjs_appLoaded = function()
    {
        console.log("[NativeApp] onjs_appLoaded");

        document.app.showMap();

    }

    /**
     * Notificates that map is loaded
     */
    NativeApp.prototype.onjs_mapLoaded = function()
    {
        console.log("[NativeApp] onjs_mapLoaded");
    }

    NativeApp.prototype.onjs_createVariant = function()
    {
        console.log("[NativeApp] onjs_createVariant");
    }
    NativeApp.prototype.onjs_updateVariant = function()
    {
        console.log("[NativeApp] onjs_updateVariant");
    }
    NativeApp.prototype.onjs_deleteVariant = function()
    {
        console.log("[NativeApp] onjs_deleteVariant");
    }

    NativeApp.prototype.onjs_zoomChanged = function(zoom){
        console.log("[NativeApp zoom changed");
        $("#navitem_slider").slider('value',zoom);
    }

    return NativeApp;
});

// @endif
