//jasmine.getFixtures().fixturesPath = 'base/test/mockups/'

define(['mapController','app', 'text!../../index.html','jquery'], function (MapController,App, doc, $) {

    describe('constructorTest', function() {

        beforeEach(function() {
            document.body.innerHTML=doc;
            this.$canvas = $('#mapCanvas');
        });

        it('canvas exists', function() {

            var mapController = new MapController(this.$canvas)
            expect(mapController.canvas).toEqual(this.$canvas[0]);
        });

        it('canvas does not exists', function() {
            var exceptionTrown=false;
            var canvas = null;
            try
            {
                var mapController = new MapController(canvas)
            }
            catch(err)
            {
                exceptionTrown=true;
                expect(err).toEqual('MapController: canvas is null');

            }
            expect(exceptionTrown).toEqual(true);
        });
    });

    /*describe('loadJson json test', function() {

        it('valid json', function() {


            var jsonString='{' +
                '   "mapProps":{' +
                '       "mapName":"firstMap"' +
                '   },' +
                '   "nodeControllers": [{' +
                '       "id": "n1",' +
                '       "nodeData": {' +
                '           "objType":"rectangle",' +
                '           "penColor":"#11223388"' +
                '       },' +
                '       "geometry": {' +
                '           "x":100,"y":100,' +
                '           "width":50,"height": 50' +
                '       }' +
                '   }]' +

                '}';

            var model=JSON.parse(jsonString);

                var canvas = $('<canvas></canvas>');
                var mapController = new MapController(canvas)
            mapController.loadJson(model);
            //check if the model has been correctly parsed by the controller
            expect(mapController.model).toEqual(model);
            //check the name of the map
            expect(mapController.model.mapProps.mapName).toEqual("firstMap");
        });
    });*/

});