/**
 * Created by roberta on 12/03/15.
 */
requirejs.config(
    {
        paths:
        {
            // external libraries
            'jquery':               '../../bower_components/jquery/dist/jquery',

            'nativeService':        'native/nativeService',
            'nativeApp':            'native/nativeApp',
            'nativeModel':          'native/nativeModel',

            // the media navigator-application
            'app':                  'app'
        }
    });


define(['app', 'nativeService', 'jquery', 'nativeApp', 'nativeModel'], function (App, NativeService, $, NativeApp, NativeModel)
{
    //$('body').on('contextmenu', function(evt) { return false; });

    var onAppLoaded = function() {
        document.app = new App($('#media-navigation'));
        document.nativeService.notifyAppLoaded();
    }

    document.nativeService = new NativeService();

    if (typeof(QWebChannel) === 'undefined') {
        if(window.nativeApp == undefined)
        {
            window.nativeApp = new NativeApp();
            window.nativeModel = new NativeModel();
        }
    }
    else {
        if (window.nativeApp == undefined) {
            new QWebChannel(qt.webChannelTransport,
                            function(channel){
                                // set up connections
                                window.nativeApp = channel.objects.nativeApp;
                                window.nativeModel = channel.objects.nativeModel;

                                channel.objects.nativeApp.sendMediaList.connect(function() {
                                    // This callback will be invoked whenever the signal is emitted on the C++ side.
                                    document.app.displayMedia(arguments[0], arguments[1]);
                                });

                                onAppLoaded();
                            }
                        );
        }
    }
});
