/* Load this script using conditional IE comments if you need to support IE 7 and IE 6. */

window.onload = function() {
	function addIcon(el, entity) {
		var html = el.innerHTML;
		el.innerHTML = '<span style="font-family: \'icomoon\'">' + entity + '</span>' + html;
	}
	var icons = {
			'icon-untitled' : '&#x3c;',
			'icon-untitled-2' : '&#x76;',
			'icon-untitled-3' : '&#x3e;',
			'icon-untitled-4' : '&#x5e;',
			'icon-untitled-5' : '&#x2b;',
			'icon-untitled-6' : '&#x2d;',
			'icon-untitled-7' : '&#xe091;',
			'icon-untitled-8' : '&#xe090;',
			'icon-untitled-9' : '&#xe092;',
			'icon-untitled-10' : '&#xe013;',
			'icon-untitled-11' : '&#x78;',
			'icon-untitled-12' : '&#xe7;',
			'icon-untitled-13' : '&#xa7;'
		},
		els = document.getElementsByTagName('*'),
		i, attr, c, el;
	for (i = 0; ; i += 1) {
		el = els[i];
		if(!el) {
			break;
		}
		attr = el.getAttribute('data-icon');
		if (attr) {
			addIcon(el, attr);
		}
		c = el.className;
		c = c.match(/icon-[^\s'"]+/);
		if (c && icons[c[0]]) {
			addIcon(el, icons[c[0]]);
		}
	}
};